#include "stdafx.h"
#include "Principal.h"
#include "Windows.h"

// A T E N   O
// A ordem de chamada dos construtores dos objetos (agredados) nesta classe
//  definida pela sua ordem de declarao na classe Principal e NO (estra-
// nhamente) pela sua ordem de chamada aqui (a partir do construtor da Principal).

Principal::Principal ( ):
// "geradores" de identificao
cont_idAluno		(0),
cont_idDisc			(0),
cont_idDepart		(0),
// Contrutores dos objetos da Classe Disciplina
Computacao1_2006	(cont_idDisc++),
Introd_Alg_2007		(cont_idDisc++),
Computacao2_2007	(cont_idDisc++),
Metodos2_2007		(cont_idDisc++),
// Contrutores dos objetos da Classe Aluno
AAA					(cont_idAluno++),
BBB					(cont_idAluno++),
CCC					(cont_idAluno++),
DDD					(cont_idAluno++),
EEE					(cont_idAluno++),
//Contrutores dos Objetos da Classe Departamento
EletronicaUTFPR		(cont_idDepart++),	
MatematicaUTFPR		(cont_idDepart++),
FisicaUTFPR			(cont_idDepart++),
MatematicaPrinceton	(cont_idDepart++),
FisicaPrinceton		(cont_idDepart++),
MatematicaCambridge	(cont_idDepart++),
FisicaCambridge		(cont_idDepart++),

// nome dos arquivos;
arqAlunos			("alunos.dat"),
arqDepartamentos	("departamentos.dat"),
arqDisciplinas		("disciplinas.dat"),
arqUniversidades	("universidades.dat")
{   
	SYSTEMTIME st;
	GetSystemTime(&st);
	//printf("Year:%d\nMonth:%d\nDate:%d\nHour:%d\nMin:%d\nSecond:% d\n" ,st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);

	diaAtual = st.wMonth;
	mesAtual = st.wDay;
	anoAtual = st.wYear;

	Inicializa();
	Executar();
}

void Principal::Inicializa()
{   
	InicializaAlunos();
	InicializaUnivesidades();
	InicializaDepartamentos();
	InicializaProfessores();
	InicializaDisciplinas();
}

void Principal::InicializaAlunos()
{
	AAA.setNome( "AAA" );
	LAlunos.incluir( AAA );

	BBB.setNome( "BBB" );
	LAlunos.incluir( BBB );

	CCC.setNome( "CCC" );
	LAlunos.incluir( CCC );

	DDD.setNome( "DDD" );
	LAlunos.incluir( DDD );

	EEE.setNome( "EEE" );
	LAlunos.incluir( EEE );
}

void Principal::InicializaUnivesidades()
{  
	// Registro do(s) nome(s) da(s) universidade(s)
	UTFPR.setNome( "UTFPR" );
	LUniversidades.incluir( UTFPR );

	Princeton.setNome( "Princeton" );
	LUniversidades.incluir( Princeton );

	Cambridge.setNome( "Cambridge" );
	LUniversidades.incluir( Cambridge );
}

void Principal::InicializaDepartamentos()
{ 
	// Registro do(s) nome(s) do(s) departamento(s)
	EletronicaUTFPR.setNome( "Eletronica UTFPR" );
	MatematicaUTFPR.setNome( "Matematica UTFPR" );
	FisicaUTFPR.setNome( "Fisica UTFPR" );
	MatematicaPrinceton.setNome( "Matematica Princeton" );
	FisicaPrinceton.setNome( "Fisica Pirnceton" );
	MatematicaCambridge.setNome( "Matematica Cambridge" );
	FisicaCambridge.setNome( "Fisica Cambridge" );

	LDepartamentos.incluir( EletronicaUTFPR );
	LDepartamentos.incluir( MatematicaUTFPR );
	LDepartamentos.incluir( FisicaUTFPR );
	LDepartamentos.incluir( MatematicaPrinceton );
	LDepartamentos.incluir( FisicaPrinceton );
	LDepartamentos.incluir( MatematicaCambridge );
	LDepartamentos.incluir( FisicaCambridge );
	 
	// "Agregao" do(s) Departamento(s) a(s) Universidade(s).
	UTFPR.incluaDepartamento( &EletronicaUTFPR );
	UTFPR.incluaDepartamento( &MatematicaUTFPR );
	UTFPR.incluaDepartamento( &FisicaUTFPR );

	Princeton.incluaDepartamento( &MatematicaPrinceton );
	Princeton.incluaDepartamento( &FisicaPrinceton );
	Cambridge.incluaDepartamento( &MatematicaCambridge );
	Cambridge.incluaDepartamento( &FisicaCambridge );
}

void Principal::InicializaProfessores()
{
	// Inicializao do(s) ojeto(s) da classe Professor
	Simao.Inicializa( 3, 10, 1976, "Jean Simo" );
	Einstein.Inicializa( 14, 3, 1879, "Albert Einstein" );
	Newton.Inicializa( 4, 1, 1643, "Isaac Newton" );

	// "Filiao" a universidade.
	Simao.setUnivFiliado( &UTFPR );
	Einstein.setUnivFiliado( &Princeton );
	Newton.setUnivFiliado( &Cambridge );

	// Area de Conhecimento.
	//Simao.setDominio( "Computao );
	//Einstein.setDominio( "Fsica" );
	//Newton.setDominio( "Matemtica-Fsica" );

	// "Filiao" ao departamento.
	Simao.setDepartamento( &EletronicaUTFPR );
	Einstein.setDepartamento( &FisicaPrinceton );
	Newton.setDepartamento( &MatematicaCambridge );
}

void Principal::InicializaDisciplinas()
{
	Computacao1_2006.setNome( "Computacao I 2006" );
	Introd_Alg_2007.setNome( "Introducao de Algoritmos de Programacao 2007" );
	Computacao2_2007.setNome( "Computao II" );
	Metodos2_2007.setNome( "Mtodos II" );

	LDisciplinas.incluir( Computacao1_2006 );
	LDisciplinas.incluir( Introd_Alg_2007 );
	LDisciplinas.incluir( Computacao2_2007 );
	LDisciplinas.incluir( Metodos2_2007 );

	Computacao1_2006.setDepartamento( &EletronicaUTFPR );
	Introd_Alg_2007.setDepartamento( &EletronicaUTFPR );
	Computacao2_2007.setDepartamento( &EletronicaUTFPR );
	Metodos2_2007.setDepartamento( &EletronicaUTFPR );

	Metodos2_2007.incluaAluno( &AAA );
	Metodos2_2007.incluaAluno( &BBB );
	Metodos2_2007.incluaAluno( &CCC );
	Metodos2_2007.incluaAluno( &DDD );
	Metodos2_2007.incluaAluno( &EEE );

	Computacao2_2007.incluaAluno( &AAA );
	Computacao2_2007.incluaAluno( &EEE );
	Computacao2_2007.incluaAluno( &DDD );
}

void Principal::CalcIdadeProfs()
{
	// Clculo da idade.
	Simao.Calc_Idade( diaAtual, mesAtual, anoAtual );
	Einstein.Calc_Idade( diaAtual, mesAtual, anoAtual );
	Newton.Calc_Idade( diaAtual, mesAtual, anoAtual );
	printf ("\n");
}

void Principal::UnivOndeProfsTrabalham()
{
	// Universidade que a Pessoa trabalha.
	Simao.OndeTrabalho();
	Einstein.OndeTrabalho();
	Newton.OndeTrabalho();

	cout << endl;
}

void Principal::DepOndeProfsTrabalham()
{
	// Departamento que a Pessoa trabalha.
	Simao.QualDepartamentoTrabalho();
	Einstein.QualDepartamentoTrabalho();
	Newton.QualDepartamentoTrabalho();
	//printf ( "\n" );
	cout << endl;
}

void Principal::ListeDiscDeptos()
{
	EletronicaUTFPR.listeDisciplinas();
	cout << endl;
}

void Principal::ListeAlunosDisc()
{
	Metodos2_2007.listeAlunos();
	cout << endl;

	Computacao2_2007.listeAlunos();  
	cout << endl;

	//Metodos2_2007.listeAlunos2();
	//cout << endl;
}

void Principal::Executar()
{
	//CalcIdadeProfs();
	//UnivOndeProfsTrabalham();
	//DepOndeProfsTrabalham();
	//ListeDiscDeptos();
	//ListeAlunosDisc();
	Menu();
}

void Principal::CadDisciplina()
{	}

void Principal::CadDepartamento()
{
	/*
	char nomeUniversidade[150];
	char nomeDepartamento[150];
	Universidade* univ;
	Departamento* depart;

	cout << "Qual o nome da universidade do departamento" << endl;
	cin  >> nomeUniversidade;

	univ = LUniversidades.localizar(nomeUniversidade);

	if ( univ != NULL )
	{
		cout << "Qual o nome do departamento" << endl;
		cin >> nomeDepartamento;
		depart = new Departamento(cont_idDepart);
		cont_idDepart++;
		depart->setNome(nomeDepartamento);
		LDepartamentos.incluir(depart);
		LUniversidades.incluir(univ);
	}
	else
	{
		cout << "Universidade inexistente." << endl;
	}
	*/
}

void Principal::CadUniversidade()
{
	char nomeUniversidade[150];
	Universidade univ;

	cout << "Qual o nome da universidade" << endl;
	cin  >> nomeUniversidade;

	univ.setNome(nomeUniversidade);

	LUniversidades.incluir( univ );
}

void Principal::CadAluno()
{
	char	nomeAluno[100];
	int		ra;
	Aluno	al(cont_idAluno++);

	cout << "Qual o nome do aluno. " << endl;
	cin  >> nomeAluno;

	cout << "Qual o RA do aluno."	<< endl;
	cin  >> ra;
	
	al.setNome(nomeAluno);
	al.setRA(ra);

	LAlunos.incluir( al );
}

void Principal::GravarTudo()
{
	GravarAlunos();
	GravarDepartamentos();
	GravarDisciplinas();
	GravarProfessores();
	GravarUniversidades();
}

void Principal::GravarUniversidades()
{
	LUniversidades.gravarEmArquivo( arqUniversidades );
}

void Principal::GravarDepartamentos()
{
	LDepartamentos.gravarEmArquivo( arqDepartamentos );
}

void Principal::GravarDisciplinas()
{
	LDisciplinas.gravarEmArquivo( arqDisciplinas );
}

void Principal::GravarAlunos()
{
	LAlunos.gravarEmArquivo( arqAlunos );
}

void Principal::GravarProfessores()
{	}

void Principal::RecuperarTudo()
{
	RecuperarAlunos();
	RecuperarDepartamentos();
	RecuperarDisciplinas();
	RecuperarProfessores();
	RecuperarUniversidades();
}

void Principal::RecuperarUniversidades()
{
	LUniversidades.recuperarDeArquivo( arqUniversidades );
}

void Principal::RecuperarDepartamentos()
{
	LDepartamentos.recuperarDeArquivo( arqDepartamentos );
}

void Principal::RecuperarDisciplinas()
{
	LDisciplinas.recuperarDeArquivo( arqDisciplinas );
}

void Principal::RecuperarAlunos()
{
	LAlunos.recuperarDeArquivo( arqAlunos );
}

void Principal::RecuperarProfessores()
{	}

void Principal::MenuCad()
{	
	int op = -1;
	while (op != 5)
	{
		system("cls");
		cout << "  Informe sua opo:			"	<< endl;
		cout << "  1 - Cadastrar Disciplina.	"	<< endl;
		cout << "  2 - Cadastrar Departamentos. "	<< endl;
		cout << "  3 - Cadastrar Universidade.	"	<< endl;
		cout << "  4 - Cadastrar Aluno.			"	<< endl;
		cout << "  5  Sair. "						<< endl;
		cin >> op;

		switch (op)
		{
			case 1 :{ CadDisciplina ();	 }
				break;

			case 2: { CadDepartamento(); }
				break;

			case 3:	{ CadUniversidade(); }
				break;

			case 4:	{ CadAluno(); }
				break;

			case 5:	{ cout << " FIM " << endl; }
				break;

			default:{                      
					  cout << "Opo Invlida - Pressione uma tecla." << endl;
					  getchar();
					}
		}
	}
}

void Principal::MenuExe()
{
    int op = -1;
    while ( op != 6 )
    {
		system("cls");
        cout << "  Informe sua opo:		"	<< endl;
        cout << "  1 - Listar Disciplinas.  "	<< endl;
        cout << "  2 - Listar Departamentos."	<< endl;
        cout << "  3 - Listar Universidade. "	<< endl;
		cout << "  4 - Listar Alunos. "			<< endl;
		cout << "  5 - Listar Professores."		<< endl;
        cout << "  6  Sair. "					<< endl;
        cin  >> op;

        switch ( op )
        {
			case 1:  { 
					   for (Elemento<Disciplina>* pAux = LDisciplinas.getPrimeiro(); pAux != NULL; pAux = pAux->getProximo())
					   {
							Disciplina obj = pAux->getInfo();
							printf("%s\n", obj.getNome());
					   }
					   fflush(stdin);
					   getchar(); 	
					 }
                break;
			case 2:  { 
				       for (Elemento<Departamento>* pAux = LDepartamentos.getPrimeiro(); pAux != NULL; pAux = pAux->getProximo())
					   {
							Departamento obj = pAux->getInfo();
							printf("%s\n", obj.getNome());
					   }
					   fflush(stdin);
					   getchar(); 
					 }
				break;
			case 3:  { 
					   for (Elemento<Universidade>* pAux = LUniversidades.getPrimeiro(); pAux != NULL; pAux = pAux->getProximo())
					   {
							Universidade obj = pAux->getInfo();
							printf("%s\n", obj.getNome());
					   }
				       fflush(stdin);
					   getchar();
					 }
				break;
			case 4:  { 
					   for (Elemento<Aluno>* pAux = LAlunos.getPrimeiro(); pAux != NULL; pAux = pAux->getProximo())
					   {
							Aluno obj = pAux->getInfo();
							printf("%s\n", obj.getNome());
					   }
					   fflush(stdin);
					   getchar();
					 }
                break;
	        case 5:  { 
						DepOndeProfsTrabalham(); 
						fflush(stdin);
						getchar();
					 }
                break; 
            case 6:  { 
						cout << " FIM " << endl; 
					 }
                break;
            default: { 
					   cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); 
					 }
        }
    }
}

void Principal::MenuGravar()
{
	int op = -1; 
    while (op != 6)
    {
		system("cls");
        cout << "  Informe sua opo:			"	<< endl;
		cout << "  0 - Gravar Tudo.				"	<< endl;
        cout << "  1 - Gravar Universidades.	"	<< endl;
        cout << "  2 - Gravar Departamentos.	"	<< endl;
		cout << "  3 - Gravar Disciplinas.		"	<< endl;
		cout << "  4 - Gravar Alunos.			"	<< endl;
		cout << "  5 - Gravar Professores.		"	<< endl;
        cout << "  6  Sair.					"	<< endl;
        cin >> op;

        switch (op)
        {
			case 0: {	GravarTudo();			 }
                break;
            case 1: {	GravarUniversidades();	 }
                break;
            case 2: {	GravarDepartamentos();	 }
				break;
			case 3: {	GravarDisciplinas();	 }
				break;
			case 4: {	GravarAlunos();			 }
				break;
			case 5: {	GravarProfessores();	 }
				break;
			case 6: {	cout << " FIM " << endl; }
                break;
            default: { cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); }
        }
    }	
}

void Principal::MenuRecuperar()
{
	int op = -1;
    
    while (op != 6)
    {
		system("cls");

        cout << "  Informe sua opo:			"	<< endl;
		cout << "  0 - Recuperar Tudo.			"	<< endl;
        cout << "  1 - Recuperar Universidades.	"	<< endl;
        cout << "  2 - Recuperar Departamentos.	"	<< endl;
		cout << "  3 - Recuperar Disciplinas.	"	<< endl;
		cout << "  4 - Recuperar Alunos.		"	<< endl;
		cout << "  5 - Recuperar Professores.	"	<< endl;
        cout << "  6  Sair.					"	<< endl;
        cin >> op;

        switch (op)
        {
			case 0: {	RecuperarTudo();			 }
                break;
            case 1: {	RecuperarUniversidades();	 }
                break;
            case 2: {	RecuperarDepartamentos();	 }
				break;
			case 3: {	RecuperarDisciplinas();	 }
				break;
			case 4: {	RecuperarAlunos();			 }
				break;
			case 5: {	RecuperarProfessores();	 }
				break;
			case 6: {	cout << " FIM " << endl; }
                break;
            default: { cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); }
        }
    }	
}

void Principal::Menu()
{
	int op = -1;
    while (op != 5)
    {
		system("cls");
        cout << "  Informe sua opo:"	<< endl;
        cout << "  1 - Cadastrar.	 "	<< endl;
        cout << "  2 - Executar.	 "	<< endl;
		cout << "  3 - Gravar.		 "  << endl;
		cout << "  4 - Recuperar.	 "  << endl;
        cout << "  5  Sair.		 "	<< endl;
        cin >> op;

        switch (op)
        {
            case 1: {	MenuCad();			}
                break;
            case 2: {	MenuExe();			}
				break;
			case 3: {	MenuGravar();		}
				break;
			case 4: {	MenuRecuperar();	}
				break;
			case 5: {	cout << " FIM " << endl; }
                break;
            default: { cout << "Opo Invlida - Pressione uma tecla." << endl;
					   getchar(); }
        }
    }	
}
